Unit Main;

(******************************************************************************)
(* Fusion Folder Keeper - Transpear Software                                  *)
(******************************************************************************)
{                                                                              }
{ VERSION      : 1.2                                                           }
{ AUTHOR       : Kelvin Westlake                                               }
{ CREATED      : 22 Semptember 2000                                            }
{ WEBSITE      : http://www.Transpear.cjb.net                                  }
{ EMAIL        : KWestlae@yahoo.com                                            }
{ Dependancies : FormEx Component                                              }
{                Icon Control Componet Lib.  (both are included+free)          }
{                                                                              }
{ NOTES:                                                                       }
{ Version 1.2 Sept 22/2000                                                     }
{                                                                              }
{ Through the suggestions of a friend who also happens to be an experienced    }
{ Delphi programmer, I don't know I should mention his name :)                 }
{ I have added/changed/improved some new features:                             }
{                            Desktop is now displayed in the menu              }
{                            Fixed Icon Routines                               }
{                            Improved Menu handling                            }
{                            Auto Startup feature                              }
{                            Options menu                                      }
{                                                                              }
{ Version 1 Sept 14/2000.                                                      }
{                                                                              }
{ I am going to start following the examples of other, all my classes will     }
{ begin with the Extension TF (Transpear Fusion) from now on, I will register  }
{ this will borland ASAP.                                                      }
{                                                                              }
{ This program is released with source just to show people the high quality of }
{ freeware components that are available for delphi, not to show my code off   }
{ but the shear quality of the FormEx (tasktray+form handler) and the Icon     }
{ list box, that in my opinion they are better than similar compoents that     }
{ come with commercial packages such as AHM Triton. although these are supberb.}
{                                                                              }
{ All forms (Editor+About) are called dynamically, so you will not find them   }
{ in the project manager, you will need to go to the file menu this is the 1st }
{ time I have tried this method, I was hoping it might free up some memory, if }
{ u have any tips for memory handling then please let me know as a blank delphi}
{ application takes up 1.2Mb of RAM on my system (not very good for Tray Apps).}
{                                                                              }
{ Sorry if my comments are long winded, but it was recently pointed out to me  }
{ that my previous attempts were not adequate enough.                          }
{                                                                              }
{ Please read the enclosed text files                                          }
{******************************************************************************}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trayicon, Menus, StdCtrls, ImgList, FormEx, ExtCtrls, ShellAPI,FileCtrl;


Const Version='v1.2';


Type MenuPosType = (ttfLeft, ttfRight, ttfMerged);

  Type MenuItemsRec = Record             // all the info we need :)
       Name      : String [30];
       Path      : String [255];
       IconPath  : String [255];
       IconIndex : Integer;
     End;


Type OptionsRec = Record                  // Basic configuration.
       AutoStart : Boolean;
       Desktop   : Boolean;
       MenuPos   : MenuPosType;
     End;


Type  DesktopClass=Class                  // Way of cheating with lists..
        FileInfo :  TSearchRec;
      End;


type
  TtfFolderKeeper = class(TForm)
    FolderMenu: TPopupMenu;
    FormEx1: TFormEx;
    IconList: TImageList;
    ControlMenu: TPopupMenu;
    AddPaths1: TMenuItem;
    HomepageItem: TMenuItem;
    EMailUsItem: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;             // Menu Seperator 1
    QuitItem: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    DesktopMenu: TMenuItem;
    N4: TMenuItem;             // Menu Seperator 2
    procedure FormCreate(Sender: TObject);

    procedure FolderExecute(Sender: TObject);

    procedure QuitItemClick(Sender: TObject);  // Control menu handlers.
    procedure EMailUsItemClick(Sender: TObject);
    procedure HomepageItemClick(Sender: TObject);
    procedure AddPaths1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
   Options      : OptionsRec;
   DataFilePath : String[255];                // store programs path
  public
    Procedure ReadDesktop;
    Procedure ReadMenuContents(Path : String);
    Procedure ReadOptions(Path : String);
    Procedure RefreshConfigs;
    Procedure ConfigureAutoStart;
  end;

var
  tfFolderKeeper: TtfFolderKeeper;

implementation

Uses Misc, Editor, About;

{$R *.DFM}


// Demtermine is file has given extension.
Function FileExt(Path, Ext : String):Boolean;
Begin
  IF Pos(AnsiLowerCase(ext),AnsiLowerCase(path))=Length(path)-3
  THEN Result:=True ELSE Result:=False;
End;


// Out of interest this used for sorting a TLIST, please see proc ReadDesktop;
// You use the pointers within the base class it is using, this not hard
// but Borland have regretable not produced very documentation on this.
Function DesktopFilelistCompare( Item1, Item2: Pointer) : Integer;
Begin
 Result:=AnsiCompareText(DesktopClass(Item1).fileinfo.name,
                         DesktopClass(Item2).fileinfo.name );
End;



// This procedure is SLOPPY .. please do not take example from this.
// Unfortunately the original code did not work the way I planned it
// to, so this Procedure was created through trial and error and I simply
// have not had the time to tidy it up. If you can makes out what is does
// then you are a VERY good coder indeed.
Procedure ttfFolderKeeper.ReadDesktop;
Var DirList : TList;
    FileList : Tlist;
    srec: TSearchRec;
    Index : Integer;
    temp: DesktopClass;
    TempM : TMenuItem;
    Count : Integer;
    IconPath,
    Target : String;
    IconIndex : Integer;
Begin
 dirList:=TList.create;
 FileList:=TList.create;
 If FindFirst( DeskTopDir+'\*.*', faAnyfile, SRec ) = 0 Then
 Repeat
  IF (SRec.name<>'.') and (SRec.name<>'..') THEN
  Begin
   temp:=DesktopClass.create;
   Temp.FileInfo:=SRec;
   IF Temp.FileInfo.Attr=faDirectory THEN DirList.Add(Temp)
   Else
   IF (FileExt(temp.FileInfo.Name,'.exe')) OR
      (FileExt(temp.FileInfo.Name,'.lnk')) THEN FileList.Add(Temp);
  End;
 Until FindNext( SRec ) <> 0;
 Dirlist.Sort(DesktopFileListCompare);
 Filelist.Sort(DesktopFileListCompare);
 For Count:=0 To DirList.Count-1 DO        //Search for Folders First
 Begin
  TempM:=TMenuItem.create(Self);
  Temp:=DirList.Items[Count];
  IF Temp.FileInfo.Attr=faDirectory THEN
  With Temp DO
  Begin
    If FileInfo.name[Length(FileInfo.name)-3]='.' THEN  //remove extensions
      SetLength(FileInfo.name,Length(FileInfo.Name)-4);
    TempM.Caption:=FileInfo.name;
    TempM.ImageIndex:=0;
    TempM.Hint:=DesktopDir+'\'+FileInfo.name;
    TempM.Onclick:=FolderExecute;
    DesktopMenu.Add(TempM);
  End;
 End;
 For Count:=0 To FileList.Count-1 DO     // Then add files ..
 Begin
  TempM:=TMenuItem.create(Self);
  Temp:=FileList.Items[Count];
  IF Temp.FileInfo.Attr<>faDirectory THEN
  With Temp DO
  Begin
    IF FileExt(FileInfo.Name,'.lnk') THEN
    Begin
     ReadShortCut(DesktopDir+'\'+FileInfo.Name,Target,IconPath,IconIndex);
     Index:=IconList.AddIcon(ExtractIconFromFile(IconPath,IconIndex,True));
    End
   Else Index:=IconList.AddIcon(ExtractIconFromFile(DesktopDir+'\'+FileInfo.Name,0,FALSE));
    TempM.ImageIndex:=Index;
    TempM.Hint:=DesktopDir+'\'+FileInfo.name;
    TempM.Onclick:=FolderExecute;
    If FileInfo.name[Length(FileInfo.name)-3]='.' THEN
        SetLength(FileInfo.name,Length(FileInfo.Name)-4);
    TempM.Caption:=FileInfo.name;
    DesktopMenu.Add(TempM);
  End;
 End;
 DirList.free;
 FileList.Free;
End;




// If given a path say 'c:\windows\system32\shell.exe' it will try to split
// the path up and return just the paths directory ie 'c:\windows\system32'
// there is probally an API call to this but I wrote this fuction more
// than 7 years ago in TP7 :)
Function SplitPath(Orig : String):String;
Var T         : string[255];
    found     : boolean;
    count     : Integer;
    Seperator : integer;
Begin
  T:=Orig;
  found:=false;
  Seperator:=Length(Orig);
  count:=0;
Repeat
 Dec(Seperator);
   If Orig[Seperator]=':' THEN
   Begin
     found:=true;
     Inc(Seperator);
   End;
   If Orig[Seperator]='\' THEN found:=true;
UNTIL (Found)  OR (Seperator=0);
 Repeat
   T[count]:=Orig[count];
   Inc(Count);
 Until Count=Seperator;
  SetLength(T,Count-1);
  SplitPath:=T;
End;




////////////////////////////////////////////////////////////////////////////////
/// Config Reading Routine
///
/// the data files are looked for in the program run directory, once a Record has
/// been read a menu item is created for it. the execute path is stored in the
/// item.hint, as this is never displayed we can make use for them.
/// if no icon has been set the .IconPath will read 'NONE' and a default folder
/// Icon will be displayed.


Procedure ttfFolderKeeper.RefreshConfigs;
Var Count : Integer;
Begin

 For Count:=ControlMenu.ComponentCount-1 DownTo 0 DO
   IF ControlMenu.Items[Count].Tag=1 THEN ControlMenu.Items[Count].free;
  DesktopMenu.clear;
  FolderMenu.Items.Clear;
  ReadOptions(dataFilePath);
  ReadMenuContents(DataFilePath);
  IF Options.Desktop THEN
  Begin
   DesktopMenu.Visible:=True;
   ReadDesktop;
  End
  ELSE DesktopMenu.Visible:=False;
    Case Options.MenuPos Of
    ttfLeft  : Begin
                FormEx1.TrayIcon.LeftPopUpMenu:= FolderMenu;
                FormEx1.TrayIcon.RightPopUpMenu:=ControlMenu;
               End;
    ttfRight : Begin
                FormEx1.TrayIcon.LeftPopUpMenu:= ControlMenu;
                FormEx1.TrayIcon.RightPopUpMenu:=FolderMenu;
               End;
    ttfMerged : Begin
                 FormEx1.TrayIcon.LeftPopUpMenu:= ControlMenu;
                 FormEx1.TrayIcon.RightPopUpMenu:=ControlMenu;
                End;

    End;
End;



Procedure ttfFolderKeeper.ReadOptions(Path : String);
Var Lock : File oF OptionsRec;
Begin
  AssignFile(Lock,Path+'\Options.dat');
{$I-}
  Reset(Lock);
{$I+}
  IF IOResult<>0 THEN          // If it fails to open the file we use defualts.
  Begin
    Options.AutoStart:=True;
    Options.MenuPos:=ttfLeft;
    Options.Desktop:=True;
    Exit;
  End;
  Read(Lock,Options);
  CloseFile(Lock);
End;

Procedure TtfFolderKeeper.ReadMenuContents(Path : String);
var f    : File oF MenuItemsRec;
    Count : Integer;
    NewItem : TMenuItem;
    Icon : TIcon;
    Index : Integer;
    List : MenuItemsRec;
Begin
AssignFile(f,Path+'\Paths.dat');
{$I-}
Reset(f);
{$I+}
IF IOResult<>0 THEN Exit;
For Count:=1 To  FileSize(f) Do
Begin
   IF Options.MenuPos=ttfMerged THEN     // Do menus need merging??
         NewItem:=TMenuItem.create(ControlMenu)  // Yes, use only control menu
   Else  NewItem:=TMenuItem.create(FolderMenu);  // no,  use seperate menu.
  Read(f,List);
  IF List.IconPath<>'NONE' THEN
  Begin
   Icon:=ExtractIconFromFile(List.IconPath,List.IconIndex,FALSE);
   Index:=IconList.AddIcon(Icon);
  end
  Else Index:=0;
  NewItem.caption:=List.Name;
  NewItem.Hint:=List.Path;
  NewItem.ImageIndex:=Index;
  NewItem.Tag:=1;    // used to determine main menu options from folders.
  NewItem.OnClick:=FolderExecute;
   IF Options.MenuPos=ttfMerged THEN
         ControlMenu.Items.Insert(0,NewItem)
   ELSE  FolderMenu.Items.Insert(0,NewItem)
  End;
 CloseFile(f);
End;



///////////////////////////////////////////////////////////////////////////////
/// Tasktray Menu handling routines.

procedure TtfFolderKeeper.FolderExecute(Sender: TObject);
Var Path : String;
begin
  Path:=(Sender As TMenuItem).Hint;
  shellexecute(application.Handle,'open',PChar(Path),nil,nil,sw_show);
end;



procedure TtfFolderKeeper.QuitItemClick(Sender: TObject);
begin
Application.Terminate;
end;


procedure TtfFolderKeeper.EMailUsItemClick(Sender: TObject);
begin
  shellexecute(application.Handle,'open','mailto:kwestlake@yahoo.com',nil,nil,sw_show);
end;



procedure TtfFolderKeeper.HomepageItemClick(Sender: TObject);
begin
 shellexecute(application.Handle,'open','http://www.transpear.cjb.net',nil,nil,sw_show);
end;


// Although ShowModal is used, we are creating these items dynamically so if the
// user clicks TrayIcon to many times more than 1 box edit box will pop-up, so
// must disable access to the tasktray for the Effect of Modal to work.
// this is the first time I have used this method, is this a problem with
// the Tray component??
procedure TtfFolderKeeper.AddPaths1Click(Sender: TObject);
Var KeeperEditor : TTFKeeperEditor;
begin
 FormEx1.TrayIcon.Enabled:=False;
 KeeperEditor:=TTFKeeperEditor.Create(Self);
 IF KeeperEditor.Execute(DataFilePath) THEN
 Begin
   RefreshConfigs;           // out with the old, and in with the new :)
 End;
 KeeperEditor.free;
 FormEx1.TrayIcon.Enabled:=True;
end;


// see above procedure for exmplanation.
procedure TtfFolderKeeper.About1Click(Sender: TObject);
Var AboutDlg : TTFAbout;
begin
 FormEx1.TrayIcon.Enabled:=False;
 AboutDlg:=TtfAbout.Create(Self);
 AboutDlg.Execute;
 AboutDlg.Free;
 FormEx1.TrayIcon.Enabled:=True;
end;



////////////////////////////////////////////////////////////////////////////////
//// Main Execute + Property calls

Procedure ttfFolderKeeper.ConfigureAutoStart;
Var AutoStart : ttfAutoStart;
Begin
  AutoStart:=ttfAutoStart.Create(Self);
  AutoStart.OnStartUp('Folder Keeper',ParamStr(0),Options.AutoStart);
  AutoStart.Free;
End;



procedure TtfFolderKeeper.FormCreate(Sender: TObject);
begin
Width:=0;
Height:=0;
DataFilePath:=SplitPath(ParamStr(0));
RefreshConfigs;
ConfigureAutoStart;
Application.Title:='Fusion Folder Keeper v1.2(c) 2000 Transpear Software';
FormEx1.TrayIcon.IconVisible:=True;
SetWindowLong( application.handle, GWL_EXSTYLE,
                GetWindowLong( application.handle, GWL_EXSTYLE )
                   or WS_EX_TOOLWINDOW and not WS_EX_APPWINDOW );
end;


end.

